/**
  *  \file client/dlg-warp.h
  *
  *  (c) 2001-2008 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_DLG_WARP_H
#define PCC_V2_CLIENT_DLG_WARP_H

#include "ui/ui.h"
#include "ui/window.h"
#include "ui/widgets.h"

class GShip;

class WShipSpeedSelector : public UINumberSelector {
    GShip* ship;
    int    orig_speed;

    void shipUpdated(int);
    void widgetUpdated(int);

    SignalConnection turn_conn;
 public:
    WShipSpeedSelector();
    WShipSpeedSelector(GShip& ship);
    ~WShipSpeedSelector();

    bool handleEvent(const UIEvent& e, bool second_pass);
    void draw(GfxCanvas& can);
    void getLayoutInfo(LayoutInfo& li);

    void doStandardDialog();

    void revert();
};

#endif
