#!/usr/bin/perl -w
#
#  This script prepares the "PlayVCR" directory for making the
#  installer.
#

use strict;

$| = 1;

my $srcdir = "..";
my $destdir = "playvcr";

my @todo = ("resource", "specs");

my $err = 0;

while (@todo) {
    my $dir = shift @todo;
    my %did;
    print "Processing $dir...\n";
    mkdir "$destdir\\$dir";
    if (opendir DIR, "$srcdir\\$dir") {
        while (defined (my $entry = readdir(DIR))) {
            if ($entry eq 'CVS' || $entry =~ /~$/ || $entry =~ /^\./ || $entry =~ /\.bak$/) {
                # ignore
            } elsif (-d "$srcdir\\$dir\\$entry") {
                # subdirectory to process later
                push @todo, "$dir\\$entry"
            } else {
                # file
                $did{"$dir\\$entry"} = 1;
                my $command = "copy /Y \"$srcdir\\$dir\\$entry\" \"$destdir\\$dir\\$entry\"";
                printf "  %-30s", "$entry...";
                if (system($command)) {
                    print STDERR "$srcdir\\$dir\\$entry: copy failed, command was '$command'\n";
                    $err = 1
                }
            }
        }
        closedir DIR;
    } else {
        print STDERR "$srcdir\\$dir: can't open\n";
        $err = 1;
    }
    if (opendir DIR, "$destdir\\$dir") {
        while (defined (my $entry = readdir(DIR))) {
            if ($entry eq '.' || $entry eq '..' || -d "$destdir\\$dir\\$entry") {
                # ...
            } elsif (!exists($did{"$dir\\$entry"})) {
                print "  Erasing '$destdir\\$dir\\$entry'\n";
                # unlink "$destdir\\$dir\\$entry";
            }
        }
        closedir DIR;
    }
}

# Generate timestamp
my @time = localtime();
open TIMESTAMP, "> $destdir\\version.txt";
printf TIMESTAMP "This package was built on %04d%02d%02d at %02d:%02d:%02d\n",
    $time[5] + 1900, $time[4] + 1, $time[3], $time[2], $time[1], $time[0];
close TIMESTAMP;
